# -*- coding: utf-8 -*-
"""
Created on Wed Apr  6 22:17:50 2016

@author: artur
"""
import numpy as np
from scipy import stats
import random
import math

xk = (1, 2, 3, 6, 7, 9)
pk = (0.1, 0.15, 0.05, 0.2, 0.1, 0.4)
arbitrary = stats.rv_discrete(name='arbitrary', values=(xk, pk))

import matplotlib.pyplot as plt
fig, ax = plt.subplots(1, 1)
ax.plot(xk, arbitrary.pmf(xk), 'ro', ms=12, mec='r')
ax.vlines(xk, 0, arbitrary.pmf(xk), colors='r', lw=4)
plt.show()

SamplDst = np.array([])
n = 16
for i in range(10000):
    R = arbitrary.rvs(size=n)
    mu = np.mean(R)
    SamplDst = np.append(SamplDst, mu)
    
plt.figure(2)
plt.hist(SamplDst, bins=20)
plt.show()

kurtosis = stats.kurtosis(SamplDst)
skewness = stats.skew(SamplDst)

echoMonthsCSV = np.genfromtxt("echoMonths.csv", delimiter=',')

monthsAlive = echoMonthsCSV[1:len(echoMonthsCSV),9]

isAlive = np.array(map(bool, echoMonthsCSV[1:len(echoMonthsCSV),0]))

numDeaths = len(isAlive) - np.sum(isAlive)

monthsToDeath = monthsAlive[~isAlive]

plt.figure(3)
plt.hist(monthsToDeath, bins=10, align='mid')
plt.show()

SamplDst2 = np.array([])
n = 10
for i in range(10000):
    SampleMonths = random.sample(monthsToDeath, n)
    mu = np.mean(SampleMonths)
    SamplDst2 = np.append(SamplDst2, mu)
    
plt.figure(4)
plt.hist(SamplDst2, bins=20)
plt.show()

PopMean = np.mean(monthsToDeath)
SampleStd = np.std(SamplDst2) #or PopStd / math.sqrt(n)

DesiredMeanInSample = 35

z = (DesiredMeanInSample-PopMean)/SampleStd
ProbDesiredMean = 1 - stats.norm.cdf(z)

#Confidence interval alfa = 95%
lb = stats.norm.ppf(0.025)
lower_limit = PopMean + SampleStd*lb

ub = stats.norm.ppf(0.975)
upper_limit = PopMean + SampleStd*ub

#Sample size for mean number of months in a sample not less than PopMean - 5 months
#with probability = 95%

PopStd = np.std(monthsToDeath)
ExpectedDifference = -5
RequiredN = (PopStd * lb / -5) ** 2

